<?php

namespace Modules\Fornecimento\Modules\AutorizacaoFornecimento\Services;

class TimeLineService
{

    protected $connection;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
        $this->connection = $entityManager->getConnection();
    }

    public function getDemanda($NRAUTOFORN)
    {
        $sql = "SELECT DISTINCT * FROM AUTOFORNE WHERE NRAUTOFORN = :NRAUTOFORN";
        try {
            $std = $this->connection->prepare($sql);
            $std->execute(['NRAUTOFORN' => $NRAUTOFORN]);
            return $std->fetchAll()[0];
        } catch (Exception $e) {
            throw $e;
        }
    }

    public function getIdAprovado($cdOperador, $nrDemanda)
    {
        $sql = "SELECT IDAPROVADO FROM APROVALCADA WHERE CDOPERADOR = :P_CDOPERADOR AND NRDEMANDA = :P_NRDEMANDA";
        try {
            $std = $this->connection->prepare($sql);
            $std->execute([
                "P_CDOPERADOR" => $cdOperador,
                "P_NRDEMANDA"  => $nrDemanda
            ]);
            return $std->fetchAll();
        } catch (Exception $e) {
            throw $e;
        }
    }

    public function returnMountedArray($aprovador, $state)
    {
        return (
            array(
                "CDOPERAPROV"   => $aprovador['CDOPERAPROV'],
                "NMALCADA"      => $aprovador['NMALCADA'],
                "NRDEMANDA"     => $aprovador['NRDEMANDA'],
                "NMOPERADOR"    => $aprovador['NMOPERADOR'],
                "IDAPROVADO"    => $aprovador['IDAPROVADO'],
                "DTAPROVACAO"   => $aprovador['DTAPROVACAO'],
                "DTINCLUSAO"    => $aprovador['DTINCLUSAO'],
                "SITUACAO"      => $state,
                "VRAPROVCMP"    => $aprovador['VRAPROVCMP'],
                "APROVPRINC"    => $aprovador['APROVPRINC'],
                "DSJUSTIFICA"   => $aprovador['DSJUSTIFICA']                
            )
        );
    }
}
